{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q+,R+,S+,T-,V+,X+}
{$M 65384,0,655360}
{$A+,B-,D-,E-,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X-}
{$N+}
Const InputFile='Input.TxT';
      OutputFile='Output.TxT';
      MaxN=21;
      MaxM=21;
      MaxL=110;
      epsout=2;
      Eps=1e-5;
Type Real=Extended;
 Var A: Array[1..MaxN, 1..MaxM] Of String[110];
     Num: Array[1..MaxN, 1..MaxN] Of Real;
     N, M: Integer;

 Procedure Init;
  Var i, j: Integer;
      nch: Char;
   Begin
    FillChar(A, SizeOf(A), 0);
    Assign(Input, InputFile);
     Reset(Input);
      ReadLn(N, M);
       Read(nch);
      For i:=1 To N Do Begin
        For j:=1 To M Do Begin
         While Not (nch In ['|', #10, #13, #26]) Do Begin
          If Not(nch In [#0..#32]) Then A[i, j]:=A[i, j]+nch;
          Read(nch);
         End;
         While (nch In ['|', #0..#25, #27..#32]) Do Read(nch);
        End;
      End;
     Close(Input);
    FillChar(Num, SizeOf(Num), 0);
   End;

 Function Eq(Const a, b: Real): Boolean;
  Begin
   Eq:=Abs(a-b)<Eps;
  End;

Type TLexem=(_End, _Open, _Close, _Add, _Sub, _Mul, _Div, _Num);

Var cnCalc: Boolean;
    nws: String;
    uk: Integer;
    mnL: Real;
    Lex: TLexem;

 Function GetNum(Var uk: Integer): Integer;
  Var a: Integer;
   Begin
    a:=0;
    While nws[uk] In ['0'..'9'] Do Begin
      a:=a*10+Ord(nws[uk])-Ord('0');
      Inc(uk);
     End;
    GetNum:=a;
   End;

 Procedure GetNextL;
  Var i, j: Integer;
   Begin
    Case nws[uk] Of
     '(': Lex:=_Open;
     ')': Lex:=_Close;
     '*': Lex:=_Mul;
     '/': Lex:=_Div;
     '+': Lex:=_Add;
     '-': Lex:=_Sub;
     #0: Lex:=_End;
     '{': Begin
           Inc(uk);
           i:=GetNum(uk); Inc(uk);
           j:=GetNum(uk); Inc(uk);
            Lex:=_Num; mnL:=0;
           If (i<=N) And (i>0) And (j<=M) And (j>0) And (A[i, j]='') Then
                     mnL:=num[i, j]
            Else cnCalc:=False;

          End;
     '0'..'9': Begin
                 Lex:=_Num;
                 mnL:=GetNum(uk);
               End;
    End;
    If Not(Lex In [_End, _Num]) Then Inc(uk);
   End;

 Function Expr: Real; Forward;

 Function Slag: Real;
  Begin
   Case Lex Of
    _Open: Begin GetNextL; Slag:=Expr; GetNextL; End;
    _Num: Begin Slag:=mnL; GetNextL; End;
    _Add: Begin GetNextL; Slag:=Slag; End;
    _Sub: Begin GetNextL; Slag:=-Slag; End;
   End;
  End;

 Function Term: Real;
  Var lf, rg: Real;
      ws: Boolean;
   Begin
    lf:=Slag;
    While Lex In [_Mul, _Div] Do Begin
      ws:=Lex=_Mul;
      GetNextL;
      rg:=Slag;
     If ws Then lf:=lf*rg
       Else Begin
        If Eq(rg, 0) Then cnCalc:=False
         Else lf:=lf/rg;
       End;
     End;
    Term:=lf;
   End;

 Function Expr: Real;
  Var lf, rg: Real;
      ws: Boolean;
   Begin
    lf:=Term;
    While Lex In [_Add, _Sub] Do Begin
      ws:=Lex=_Add;
      GetNextL;
      rg:=Term;
     If ws Then lf:=lf+rg
       Else lf:=lf-rg;
    End;
    Expr:=lf;
   End;

 Function CanDate(Const k, p: Integer): Boolean;
  Begin
   nws:=A[k, p]+#0;
    uk:=1;
   cnCalc:=True;
    GetNextL;
   num[k, p]:=Expr;
    If cnCalc Then A[k, p]:='';
   CanDate:=cnCalc;
  End;

 Function UpDate: Boolean;
  Var p: Boolean;
      i, j: Integer;
   Begin
    p:=False;
    For i:=1 To N Do
    For j:=1 To M Do
    If A[i, j]<>'' Then
     If CanDate(i, j) Then p:=True;
    UpDate:=p;
   End;

 Procedure Solve;
  Begin
   While UpDate Do ;
  End;

 Procedure Done;
  Var i, j: Integer;
   Begin
    Assign(Output, OutputFile);
     Rewrite(Output);
      For i:=1 To N Do Begin
       For j:=1 To M Do Begin
        If A[i, j]='' Then Write(Num[i, j]:0:epsout)
         Else Write('-');
        If j<M Then Write(' ');
       End;
       WriteLn;
      End;
     Close(Output);
   End;

BEGIN
 Init;
  Solve;
 Done;
END.